config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html

  resources :posts do
    resources :comments
  end
  root "posts#index"

end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/comment.rb
class Comment < ApplicationRecord
  belongs_to :post
end

app/models/post.rb
class Post < ApplicationRecord
  has_many :comments
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  before_action :configure_permitted_parameters, if: :devise_controller?

  protected

  def configure_permitted_parameters
    devise_parameter_sanitizer.permit(:sign_up, keys: [:username])
  end
end

app/controllers/comments_controller.rb
class CommentsController < ApplicationController
  def create
    @post = Post.find(params[:post_id])
    @comment = @post.comments.create(params[:comment].permit(:user, :comment))
    redirect_to post_path(@post)
  end

  def destroy
    @post = Post.find(params[:post_id])
		@comment = @post.comments.find(params[:id])
		@comment.destroy
		redirect_to post_path(@post)
  end
end

app/controllers/posts_controller.rb
class PostsController < ApplicationController
  before_action :find_post, only: [:show, :update, :destroy]
  before_action :authenticate_user!, except: [:show, :index]
  def index
    @post = Post.new
    @posts = Post.all.order("created_at DESC")
  end

  def create
    @post = Post.new(post_params)

    if @post.save
      redirect_to request.referrer
    else
      render 'index'
    end
  end

  def show
  end

  def update

    if @post.update(post_params)
      redirect_to @post
    else
      render 'index'
    end
  end

  def edit
    @post = Post.find(params[:id])
  end

  def destroy
    @post.destroy

    redirect_to posts_path
  end

  private

  def post_params
    params.require(:post).permit(:user, :post)
  end

  def find_post
    @post = Post.find(params[:id])
  end

end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/comments_helper.rb
module CommentsHelper
end

app/helpers/posts_helper.rb
module PostsHelper
end

app/views/comments/_comment.html.erb
<div class="box">
  <article class="media">
    <div class="media-content">
      <div class="content">
        <p>
          <strong><%= comment.user %>:</strong>
          <%= comment.comment %>
        </p>
      </div>
    </div>
     <%= link_to 'Delete', [comment.post, comment],
                  method: :delete, class: "button is-danger", data: { confirm: 'Anda yakin?' } %>
  </article>

</div>

app/views/comments/_form.html.erb
<%= simple_form_for([@post, @post.comments.build]) do |f| %>
<!--
collection.build(attributes = {}, …) Returns one or more new objects of the collection type that have been instantiated with attributes and linked to this object through a foreign key, but have not yet been saved. Note: This only works if an associated object already exists, not if it‘s nil!
-->
<div class="field">
  <div class="control">
    <%= f.input :user, input_html: { class: 'input' }, wrapper: false, label_html: { class: 'label' } %>
  </div>
</div>

<div class="field">
  <div class="control">
    <%= f.input :comment, input_html: { class: 'textarea' }, wrapper: false, label_html: { class: 'label' }  %>
  </div>
</div>
<%= f.button :submit, 'Beri Komentar', class: "button is-info" %>
<% end %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Social</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <section class="hero is-info is-small">
    <!-- Hero head: will stick at the top -->
    <div class="hero-head">
      <nav class="navbar">
        <div class="container">
          <div class="navbar-brand">
            <%= link_to 'Social', root_path, class: "navbar-item" %>
            <span class="navbar-burger burger" data-target="navbarMenuHeroA">
              <span></span>
              <span></span>
              <span></span>
            </span>
          </div>
          <div id="navbarMenuHeroA" class="navbar-menu">
            <% if user_signed_in? %>
              <div class="navbar-end">
                <%= link_to 'Logout', destroy_user_session_path, method: :delete, class:"navbar-item" %>
              </div>
            <% else %>
              <div class="navbar-end">
                <%= link_to "Login", new_user_session_path, class:"navbar-item" %>
              </div>
            <% end %>
          </div>
        </div>
      </nav>
    </div>

    <!-- Hero content: will be in the middle -->
    <div class="hero-body">
      <div class="container has-text-centered">
        <h1 class="title">
          <%= yield :page_title %>
        </h1>
      </div>
    </div>
    </section>
    <%= yield %>
  </body>
</html>

app/views/posts/_form.html.erb
<section class="section">
  <%= simple_form_for @post do |f| %>
  <div class="field">
    <div class="control">
      <%= f.input :user, input_html: {class: 'input'}, wrapper:false, label_html: { class: 'label'} %>
    </div>
  </div>
  <div class="field">
    <div class="control">
      <%= f.input :post, input_html: {class: 'textarea'}, wrapper:false, label_html: { class: 'label'} %>
    </div>
  </div>
  <%= f.button :submit, 'Buat Posting Baru', class:'button is-info' %>
  <% end %>
</section>

app/views/posts/edit.html.erb
<section class="section">
  <%= simple_form_for @post do |f| %>
  <div class="field">
    <div class="content">
      <h1> <%= @post.user%> </h1>
    </div>
  </div>
  <div class="field">
    <div class="control">
      <%= f.input :post, input_html: {class: 'textarea'}, wrapper:false, label_html: { class: 'label'} %>
    </div>
  </div>
  <%= f.button :submit, 'Edit Posting', class:'button is-info' %>
  <% end %>
</section>

app/views/posts/index.html.erb
<% if user_signed_in? %>
  <%= render 'form' %>
<% end %>
<!-- konten post -->
<section class="section">
  <div class="content">
    <% @posts.each do |post| %>
      <div class="card">
        <div class="card-content">
          <div class="media">
            <div class="media-content">
              <p class="has-text-right"><%= post.created_at %></p>
              <h3 class="user is-4"><%= post.user %></h3>
            </div>
          </div>
          <div class="content">
            <p> <%= link_to post.post, post %> </p>
          </div>
        </div>
      </div>
      <% end %>
  </div>
</section>

app/views/posts/show.html.erb
<section class="section">
  <div class="container">
    <nav class="level">
      <!-- kiri -->
      <div class="level-left">
        <p class="level-item">
        </p>
      </div>
      <% if user_signed_in? %>
      <!-- kanan -->
      <div class="level-right">
        <p class="level-item">
		    	<%= link_to "Edit", edit_post_path(@post), class:"button" %>
        </p>
        <p class="level-item">
        <%= link_to "Delete", post_path(@post), method: :delete, data: { confirm: "Anda yakin?" }, class:"button is-danger" %>
        </p>
      </div>
      <% end %>
    </nav>

  </div>
  <div class="content">
    <h1 class="user"><%= @post.user %></h1>
    <div class="post">
      <%= @post.post %>
    </div>
  </div>
</section>

<section class="section comments">
	<div class="container">
		<h2 class="subtitle is-5"><strong><%= @post.comments.count %></strong> Comments</h2>
		<%= render @post.comments %>
    <% if user_signed_in? %>
		<div class="comment-form">
			<hr />
			<h3 class="subtitle is-3">Beri Komentar</h3>
	 		<%= render 'comments/form' %>
		</div>
    <% end %>
	</div>
</section>